---
title: MediaTrackConstraints.cursor
slug: Web/API/MediaTrackConstraints/cursor
tags:
  - API
  - Capture
  - Constraints
  - Media
  - Media Capture and Streams
  - Media Capture and Streams API
  - MediaTrackConstraints
  - Property
  - Reference
  - Screen Capture
  - Screen Capture API
  - Sharing
  - Video
  - display
  - screen
---
<div>{{APIRef("Media Capture and Streams")}}</div>

<p>The {{domxref("MediaTrackConstraints")}} dictionary's <strong><code>cursor</code></strong> property is a {{domxref("ConstrainDOMString")}} describing the requested or mandatory constraints placed upon the value of the {{domxref("MediaTrackSettings.cursor", "cursor")}} constrainable property, which is used to specify whether or not the cursor should be included in the captured video.</p>

<p>If needed, you can determine whether or not this constraint is supported by checking the value of {{domxref("MediaTrackSupportedConstraints.cursor")}} as returned by a call to {{domxref("MediaDevices.getSupportedConstraints()")}}. However, typically this is unnecessary since browsers will ignore any constraints they're unfamiliar with.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>constraintsObject</em> = { cursor: <em>constraint</em> };

<em>constraintsObject</em>.cursor = <em>constraint</em>;
</pre>

<h3 id="Value">Value</h3>

<p>A {{domxref("ConstrainDOMString")}} which specifies whether or not the mouse cursor should be rendered into the video track in the {{domxref("MediaStream")}} returned by the call to {{domxref("MediaDevices.getDisplayMedia", "getDisplayMedia()")}}. See {{SectionOnPage("/en-US/docs/Web/API/Media_Streams_API/Constraints", "How constraints are defined")}} for an explanation of how to define constraints.</p>

<h2 id="Usage_notes">Usage notes</h2>

<p>You can check the setting selected by the user agent after the display media has been created by {{domxref("MediaDevices.getDisplayMedia", "getDisplayMedia()")}} by calling {{domxref("MediaStreamTrack.getSettings", "getSettings()")}} on the display media's video {{domxref("MediaStreamTrack")}}, then checking the value of  the returned {{domxref("MediaTrackSettings")}} object's {{domxref("MediaTrackSettings.cursor", "cursor")}} object.</p>

<p>For example, if your app needs to alter the stream by inserting a representation of the cursor position if the stream doesn't include the rendered cursor, you can determine the need to do so by using code like this:</p>

<pre class="brush: js">let insertFakeCursorFlag = false;

if (displayStream.getVideoTracks()[0].getSettings().cursor === "never") {
  insertFakeCursorFlag = true;
}
</pre>

<p>Following this code, <code>insertFakeCursorFlag</code> is <code>true</code> if there's no cursor rendered into the stream already. Later code can detect this flag's value and if it's <code>true</code>, can manually look at some metadata that might be provided and insert a fake representation of the cursor at the correct position.</p>

<h2 id="Example">Examples</h2>

<p>Here are some example constraints objects for <code>getDisplayMedia()</code> that make use of the <code>cursor</code> property. In addition, see {{SectionOnPage("/en-US/docs/Web/API/Media_Streams_API/Constraints", "Example: Constraint exerciser")}} for a complete example showing how constraints are used.</p>

<h3 id="Example_Cursor_always_visible">Example: Cursor always visible</h3>

<p>This example sets up the constraints to request that the cursor always be visible.</p>

<pre class="brush: js">let displayMediaOptions = {
  cursor: "always"
};
</pre>

<h3 id="Example_Cursor_visible_during_motion_with_fallback">Example: Cursor visible during motion with fallback</h3>

<p>In this example, the <code>cursor</code> property is configured to request that the cursor be visible when in motion, falling back to always being visible if the user agent doesn't support in-motion only cursor rendering.</p>

<pre class="brush: js">let displayMediaOptions = {
  cursor: ["motion", "always"]
};</pre>

<h3 id="Example_Require_that_the_cursor_not_be_visible">Example: Require that the cursor not be visible</h3>

<p>This constraints object explicitly requires that the cursor <em>not</em> be rendered into the video track.</p>

<pre class="brush: js">let displayMediaOptions = {
  cursor: {
    exact: "none"
  }
};
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{ SpecName('Screen Capture', '#dom-mediatrackconstraintset-cursor', 'MediaTrackConstraints.cursor') }}</td>
   <td>{{ Spec2('Screen Capture API') }}</td>
   <td>Initial specification.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.MediaTrackConstraints.cursor")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Screen_Capture_API">Screen Capture API</a></li>
 <li><a href="/en-US/docs/Web/API/Screen_Capture_API/Using_Screen_Capture">Using the Screen Capture API</a></li>
 <li><a href="/en-US/docs/Web/API/Media_Streams_API/Constraints">Capabilities, constraints, and settings</a></li>
 <li>{{domxref("MediaTrackConstraints")}}</li>
 <li>{{domxref("MediaDevices.getSupportedConstraints()")}}</li>
 <li>{{domxref("MediaTrackSupportedConstraints")}}</li>
</ul>
